Subject: Re: bug#56743: 29.0.50; Sharing .eln files beween different builds

From: Lars Ingebrigtsen <[email-masked]>
Date: Tue, 26 Jul 2022 13:48:01 +0200

Stefan Monnier via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <[email-masked]> writes:

> IIUC this mostly means that all the Gtk/Lucid/X11-specific
> functions&variables exported to ELisp will need to be exported in all
> the builds (probably with dummy definitions).

I think that's an interesting idea.  Currently, there's this odd
difference between C- and Lisp-defined functions/variables, where
Lisp-defined ones are always available, even if the Emacs build doesn't
support the feature, and the C ones aren't.

So it makes sense conceptually to move the DEFUN/DEFVARs outside the
#ifdefs (but stub out the innards).  However, I think that'll lead to a
lot of regressions in code out there -- it's super common (and
recommended practice) to check whether a C level function is fboundp as
a signal that it works, and making these functions always available
would break that.

So I don't think this is a feasible direction to go in.